/* inv_func.c: This file contains the abstract inverter functions for 
 * the Solarmax proxy.
 * Version: 0.1
 * Authors: Axel C. Voigt
 * Date: October 26, 2009
 */

//#include "inv_func.h" /* abstract inverters functions */
#include "sw_func.h"    /* Sunways inverters */
#include "comm_func.h"  /* socket communication */

extern solarmax_data smdata[MAX_UNITS];

static int invType= -1;

/* ------------------------------------------------------------------------- */
/* setInverterType                                                           */
/* ------------------------------------------------------------------------- */
void setInverterType(int type)
{
	invType= type;
}

char* getModelStr(int model, char* str)
{
	 switch(invType)
	 {
		case -1:
			return NULL; /* type not set */
		break;
		default:
			/* Sunways */
			return sw_getModelStr( model, str );
		break;
	}
}
/* ----- setInverterType --------------------------------------------------- */

/* ------------------------------------------------------------------------- */
/* scanInverters                                                             */
/* ------------------------------------------------------------------------- */
int scanInverters(Socket* skt, int max)
{
	switch(invType)
	{
		case -1:
			return -1; /* type not set */
		break;
		default:
			/* Sunways */
			return sw_scanInverters( skt, max );
		break;
	}
}
/* ----- scanInverters ----------------------------------------------------- */

/* ------------------------------------------------------------------------- */
/* setInverterTime                                                           */
/* ------------------------------------------------------------------------- */
int setInverterTime(Socket* skt)
{
	switch(invType)
	{
		case -1:
			return -1; /* type not set */
		break;
		default:
			/* Sunways */
			return sw_setTime( skt );
		break;
	}
}
/* ----- setInverterTime --------------------------------------------------- */

/* ------------------------------------------------------------------------- */
/* getInverterValues                                                         */
/* ------------------------------------------------------------------------- */
int getInverterValues(Socket* skt, int num)
{
	if(NULL==skt)
		return -2;
	switch(invType)
	{
		case -1:
			return -1; /* type not set */
		break;
		default:
			/* Sunways */
			return sw_getOnlineResults(skt, num);
		break;
	}
}
/* ----- getInverterValues ------------------------------------------------- */
