/* sw_func.h: This file contains the Sunways functions header file for the 
 * Solarmax proxy.
 * Version: 0.1
 * Authors: Axel C. Voigt
 * Date:    October 26, 2009
 */
#ifndef SMP_SWFUNC_H
#define SMP_SWFUNC_H

#ifdef __cplusplus
  extern "C" {
#endif

#include "sockets.h"
#include "smp.h"

/* Sunways types: values agreed with Manfred Richter */

/* Sunways NT */
#define NT2600 0x1200 /* 2500W */
#define NT4000 0x1201 /* 3700W */ 
#define NT5000 0x1202 /* 4200W */
#define NT6000 0x1203 /* 4600W */
#define NT8000 0x1204 /* 8000W */
#define NT10000 0x1205 /* 10000W */

/* Sunways AT */
/*#define AT2700, TYP 1210, 2700W
#define AT3600, TYP 1211, 3600W
#define AT4500, TYP 1212, 4500W
#define AT5000, TYP 1213, 4600W*/

/* Sunways PT */
/*#define PT30k, TYP 1220, 30000W
#define PT33k, TYP 1221, 33333W
*/

/* read */
#define SW_READ_ERRCOD 1
#define SW_READ_ONLINE 2
#define SW_READ_DAY    3
#define SW_READ_MONTOT 4
#define SW_READ_MIN1ST 5
#define SW_READ_TIME   6
#define SW_READ_MIN2ND 7
#define SW_READ_SERNUM 8
#define SW_READ_FWPROT 9
//#define SW_CMD_SN 10-15 /* Minutenwerte NT10000 */
#define SW_READ_PARAM  16
#define SW_READ_LANG   17

#define SW_WRITE_DATTIM1 50
#define SW_WRITE_DATTIM2 51
#define SW_WRITE_DATTIM3 52
#define SW_WRITE_DATTIM4 53
#define SW_WRITE_DATTIM5 54

/* functions */
int sw_checkType (char* serial, char* typstr);
int sw_scanInverters (Socket* skt, int max);
int sw_setTime (Socket* skt);
int sw_getOnlineResults (Socket* skt, int num);
char* sw_getModelStr (int model, char* str);
int sw_translateStatusCode (int status);

# ifdef __cplusplus
	}
# endif
#endif /* #ifndef SMP_SWFUNC_H */
